# Class RichTextAreaSkin

java.lang.Object
javafx.scene.control.SkinBase<RichTextArea>
jfx.incubator.scene.control.richtext.skin.RichTextAreaSkin

All Implemented Interfaces:
  `Skin<RichTextArea>`

Direct Known Subclasses:
  `CodeAreaSkin`

public class RichTextAreaSkin extends SkinBase<RichTextArea>
Provides visual representation for RichTextArea.

This skin consists of a top level Pane that manages the following children:

- virtual flow Pane
- horizontal scroll bar
- vertical scroll bar

Since:
  24

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `RichTextAreaSkin(RichTextArea control)`
  Constructs the skin.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `applyStyles(CellContext context, StyleAttributeMap attrs, boolean forParagraph)`
  Applies styles based on supplied attribute set to either the whole paragraph or the text segment.
  `void`
  `copyText(DataFormat format)`
  Copies the text in the specified format when selection exists and when the export in this format is supported by the model, and the skin must be installed; otherwise, this method is a no-op.
  `protected ScrollBar`
  `createHScrollBar()`
  Creates the horizontal scroll bar.
  `protected ScrollBar`
  `createVScrollBar()`
  Creates the vertical scroll bar.
  `void`
  `executeAccessibleAction(AccessibleAction action, Object... parameters)`
  This method is called by the assistive technology to request the action indicated by the argument should be executed.
  `StyleResolver`
  `getStyleResolver()`
  Returns the skin's `StyleResolver`.
  `void`
  `pasteText(DataFormat format)`
  Pastes the clipboard content at the caret, or, if selection exists, replacing the selected text.
  `void`
  `refreshLayout()`
  Discards any cached layout information and calls `requestLayout()`.

  ### Methods declared in class javafx.scene.control.SkinBase

  `computeBaselineOffset, computeMaxHeight, computeMaxWidth, computeMinHeight, computeMinWidth, computePrefHeight, computePrefWidth, consumeMouseEvents, dispose, getChildren, getClassCssMetaData, getCssMetaData, getNode, getSkinnable, layoutChildren, layoutInArea, layoutInArea, layoutInArea, positionInArea, positionInArea, pseudoClassStateChanged, queryAccessibleAttribute, registerChangeListener, registerInvalidationListener, registerListChangeListener, snappedBottomInset, snappedLeftInset, snappedRightInset, snappedTopInset, snapPosition, snapPositionX, snapPositionY, snapSize, snapSizeX, snapSizeY, snapSpace, snapSpaceX, snapSpaceY, unregisterChangeListeners, unregisterInvalidationListeners, unregisterListChangeListeners`

  ### Methods declared in class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

  ### Methods declared in interface javafx.scene.control.Skin

  `install`

- ## Constructor Details

  - ### RichTextAreaSkin

    public RichTextAreaSkin(RichTextArea control)
    Constructs the skin.
    Parameters:
      `control` - the owner

- ## Method Details

  - ### createVScrollBar

    protected ScrollBar createVScrollBar()
    Creates the vertical scroll bar.

    The subclasses may override this method to provide custom ScrollBar implementation.

    Returns:
      the vertical scroll bar

  - ### createHScrollBar

    protected ScrollBar createHScrollBar()
    Creates the horizontal scroll bar.

    The subclasses may override this method to provide custom ScrollBar implementation.

    Returns:
      the horizontal scroll bar

  - ### getStyleResolver

    public StyleResolver getStyleResolver()
    Returns the skin's `StyleResolver`.
    Returns:
      style resolver instance

  - ### copyText

    public void copyText(DataFormat format)
    Copies the text in the specified format when selection exists and when the export in this format is supported by the model, and the skin must be installed; otherwise, this method is a no-op.
    Parameters:
      `format` - data format

  - ### pasteText

    public void pasteText(DataFormat format)
    Pastes the clipboard content at the caret, or, if selection exists, replacing the selected text. The format must be supported by the model, and the skin must be installed, otherwise this method has no effect.
    Parameters:
      `format` - data format

  - ### applyStyles

    public void applyStyles(CellContext context, StyleAttributeMap attrs, boolean forParagraph)
    Applies styles based on supplied attribute set to either the whole paragraph or the text segment. This method can be overriden by other skin implementations to provide additional styling. The overriding method must call super implementation.
    Parameters:
      `context` - the cell context
      `attrs` - the attributes
      `forParagraph` - determines whether the styles are applied to the paragraph (true), or text segment (false)

  - ### refreshLayout

    public void refreshLayout()
    Discards any cached layout information and calls `requestLayout()`.

  - ### executeAccessibleAction

    public void executeAccessibleAction(AccessibleAction action, Object... parameters)
    Description copied from class: `SkinBase`
    This method is called by the assistive technology to request the action indicated by the argument should be executed.

    This method is commonly overridden by subclasses to implement action that are required for a specific role.
    If a particular action is not handled, the superclass implementation must be called.

    Overrides:
      `executeAccessibleAction` in class `SkinBase<RichTextArea>`
    Parameters:
      `action` - the action to execute
      `parameters` - optional list of parameters
    See Also:
      - `AccessibleAction`
      - `Node.executeAccessibleAction(javafx.scene.AccessibleAction, java.lang.Object...)`